/[gentoo-x86]/eclass/kde4-functions.eclass
Gentoo

Contents of /eclass/kde4-functions.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.32 - (hide annotations) (download)
Mon Jul 19 16:15:14 2010 UTC (4 years, 5 months ago) by reavertm
Branch: MAIN
Changes since 1.31: +2 -2 lines
Use defined mechanism (die) to terminate processing when invalid EAPI detected.

1 reavertm 1.30 # Copyright 1999-2010 Gentoo Foundation
2 ingmar 1.1 # Distributed under the terms of the GNU General Public License v2
3 reavertm 1.32 # $Header: /var/cvsroot/gentoo-x86/eclass/kde4-functions.eclass,v 1.31 2010/05/15 15:19:04 reavertm Exp $
4 ingmar 1.1
5 alexxy 1.25 inherit versionator
6    
7 ingmar 1.1 # @ECLASS: kde4-functions.eclass
8     # @MAINTAINER:
9     # kde@gentoo.org
10 scarabeus 1.10 # @BLURB: Common ebuild functions for KDE 4 packages
11 ingmar 1.1 # @DESCRIPTION:
12     # This eclass contains all functions shared by the different eclasses,
13 scarabeus 1.10 # for KDE 4 ebuilds.
14    
15     # @ECLASS-VARIABLE: EAPI
16     # @DESCRIPTION:
17 wired 1.22 # By default kde4 eclasses want EAPI 2 which might be redefinable to newer
18 scarabeus 1.14 # versions.
19     case ${EAPI:-0} in
20 abcd 1.28 2|3) : ;;
21 reavertm 1.32 *) die "EAPI=${EAPI} is not supported" ;;
22 scarabeus 1.10 esac
23 ingmar 1.1
24     # @ECLASS-VARIABLE: KDEBASE
25     # @DESCRIPTION:
26     # This gets set to a non-zero value when a package is considered a kde or
27     # koffice ebuild.
28 scarabeus 1.15 if [[ ${CATEGORY} = kde-base ]]; then
29 ingmar 1.1 debug-print "${ECLASS}: KDEBASE ebuild recognized"
30 scarabeus 1.10 KDEBASE=kde-base
31 reavertm 1.31 elif [[ ${KMNAME} = koffice || ${PN} = koffice ]]; then
32 ingmar 1.1 debug-print "${ECLASS}: KOFFICE ebuild recognized"
33 scarabeus 1.10 KDEBASE=koffice
34 reavertm 1.31 elif [[ ${KMNAME} = kdevelop ]]; then
35     debug-print "${ECLASS}: KDEVELOP ebuild recognized"
36     KDEBASE="kdevelop"
37 ingmar 1.1 fi
38    
39 jmbsvicetto 1.8 # @ECLASS-VARIABLE: KDE_SLOTS
40     # @DESCRIPTION:
41 scarabeus 1.15 # The slots used by all KDE versions later than 4.0. The live KDE releases use
42     # KDE_LIVE_SLOTS instead. Values should be ordered.
43 reavertm 1.30 KDE_SLOTS=( "4.1" "4.2" "4.3" "4.4" "4.5" )
44 jmbsvicetto 1.8
45     # @ECLASS-VARIABLE: KDE_LIVE_SLOTS
46     # @DESCRIPTION:
47 scarabeus 1.15 # The slots used by KDE live versions. Values should be ordered.
48     KDE_LIVE_SLOTS=( "live" )
49 ingmar 1.1
50 scarabeus 1.24 # @FUNCTION: slot_is_at_least
51     # @USAGE: <want> <have>
52     # @DESCRIPTION:
53     # Version aware slot comparator.
54     # Current implementation relies on the fact, that slots can be compared like
55     # string literals (and let's keep it this way).
56     slot_is_at_least() {
57     [[ "${2}" > "${1}" || "${2}" = "${1}" ]]
58     }
59    
60 ingmar 1.1 # @FUNCTION: buildsycoca
61     # @DESCRIPTION:
62     # Function to rebuild the KDE System Configuration Cache.
63     # All KDE ebuilds should run this in pkg_postinst and pkg_postrm.
64     buildsycoca() {
65     debug-print-function ${FUNCNAME} "$@"
66 scarabeus 1.19
67 abcd 1.29 if [[ ${EAPI} == 2 ]] && ! use prefix; then
68     EROOT=${ROOT}
69     fi
70 abcd 1.28
71 wired 1.22 local KDE3DIR="${EROOT}usr/kde/3.5"
72     if [[ -z ${EROOT%%/} && -x "${KDE3DIR}"/bin/kbuildsycoca ]]; then
73     # Since KDE3 is aware of shortcuts in /usr, rebuild database
74     # for KDE3 as well.
75     touch "${KDE3DIR}"/share/services/ksycoca
76     chmod 644 "${KDE3DIR}"/share/services/ksycoca
77    
78     ebegin "Running kbuildsycoca to build global database"
79     XDG_DATA_DIRS="${EROOT}usr/local/share:${KDE3DIR}/share:${EROOT}usr/share" \
80     DISPLAY="" \
81     "${KDE3DIR}"/bin/kbuildsycoca --global --noincremental &> /dev/null
82     eend $?
83     fi
84    
85 alexxy 1.25 # We no longer need to run kbuildsycoca4, as kded does that automatically, as needed
86 scarabeus 1.15
87     # fix permission for some directories
88 wired 1.22 for x in share/{config,kde4}; do
89 abcd 1.29 [[ ${KDEDIR} == /usr ]] && DIRS=${EROOT}usr || DIRS="${EROOT}usr ${EROOT}${KDEDIR}"
90 scarabeus 1.17 for y in ${DIRS}; do
91     [[ -d "${y}/${x}" ]] || break # nothing to do if directory does not exist
92     if [[ $(stat --format=%a "${y}/${x}") != 755 ]]; then
93     ewarn "QA Notice:"
94     ewarn "Package ${PN} is breaking ${y}/${x} permissions."
95     ewarn "Please report this issue to gentoo bugzilla."
96     einfo "Permissions will get adjusted automatically now."
97     find "${y}/${x}" -type d -print0 | xargs -0 chmod 755
98     fi
99     done
100 scarabeus 1.15 done
101 ingmar 1.1 }
102    
103     # @FUNCTION: comment_all_add_subdirectory
104     # @USAGE: [list of directory names]
105     # @DESCRIPTION:
106 scarabeus 1.10 # Recursively comment all add_subdirectory instructions in listed directories,
107     # except those in cmake/.
108 ingmar 1.1 comment_all_add_subdirectory() {
109     find "$@" -name CMakeLists.txt -print0 | grep -vFzZ "./cmake" | \
110 wired 1.22 xargs -0 sed -i \
111     -e '/^[[:space:]]*add_subdirectory/s/^/#DONOTCOMPILE /' \
112     -e '/^[[:space:]]*ADD_SUBDIRECTORY/s/^/#DONOTCOMPILE /' \
113     -e '/^[[:space:]]*macro_optional_add_subdirectory/s/^/#DONOTCOMPILE /' \
114     -e '/^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY/s/^/#DONOTCOMPILE /' \
115     || die "${LINENO}: Initial sed died"
116 ingmar 1.1 }
117    
118 zlin 1.5 # @ECLASS-VARIABLE: KDE_LINGUAS
119     # @DESCRIPTION:
120 scarabeus 1.10 # This is a whitespace-separated list of translations this ebuild supports.
121     # These translations are automatically added to IUSE. Therefore ebuilds must set
122     # this variable before inheriting any eclasses. To enable only selected
123 scarabeus 1.19 # translations, ebuilds must call enable_selected_linguas(). kde4-{base,meta}.eclass does
124 zlin 1.5 # this for you.
125     #
126     # Example: KDE_LINGUAS="en_GB de nl"
127     for _lingua in ${KDE_LINGUAS}; do
128     IUSE="${IUSE} linguas_${_lingua}"
129     done
130    
131     # @FUNCTION: enable_selected_linguas
132     # @DESCRIPTION:
133 scarabeus 1.10 # Enable translations based on LINGUAS settings and translations supported by
134     # the package (see KDE_LINGUAS). By default, translations are found in "${S}"/po
135 zlin 1.5 # but this default can be overridden by defining KDE_LINGUAS_DIR.
136     enable_selected_linguas() {
137 wired 1.22 debug-print-function ${FUNCNAME} "$@"
138    
139     local lingua linguas sr_mess wp
140 scarabeus 1.10
141 scarabeus 1.19 # if there is no linguas defined we enable everything
142 scarabeus 1.20 if ! $(env | grep -q "^LINGUAS="); then
143     return 0
144     fi
145 wired 1.22
146     # @ECLASS-VARIABLE: KDE_LINGUAS_DIR
147     # @DESCRIPTION:
148     # Specified folder where application translations are located.
149     KDE_LINGUAS_DIR=${KDE_LINGUAS_DIR:="po"}
150     [[ -d "${KDE_LINGUAS_DIR}" ]] || die "wrong linguas dir specified"
151     comment_all_add_subdirectory "${KDE_LINGUAS_DIR}"
152     pushd "${KDE_LINGUAS_DIR}" > /dev/null
153 scarabeus 1.10
154     # fix all various crazy sr@Latn variations
155     # this part is only ease for ebuilds, so there wont be any die when this
156     # fail at any point
157     sr_mess="sr@latn sr@latin sr@Latin"
158     for wp in ${sr_mess}; do
159 scarabeus 1.15 [[ -e "${wp}.po" ]] && mv "${wp}.po" "sr@Latn.po"
160     if [[ -d "${wp}" ]]; then
161 scarabeus 1.10 # move dir and fix cmakelists
162 scarabeus 1.15 mv "${wp}" "sr@Latn"
163 scarabeus 1.10 sed -i \
164 scarabeus 1.15 -e "s:${wp}:sr@Latin:g" \
165 scarabeus 1.10 CMakeLists.txt
166     fi
167     done
168 jmbsvicetto 1.8
169     for lingua in ${KDE_LINGUAS}; do
170 scarabeus 1.15 if [[ -e "${lingua}.po" ]]; then
171     mv "${lingua}.po" "${lingua}.po.old"
172 jmbsvicetto 1.8 fi
173     done
174 wired 1.22
175 scarabeus 1.19 for lingua in ${KDE_LINGUAS}; do
176     if use linguas_${lingua} ; then
177     if [[ -d "${lingua}" ]]; then
178 wired 1.22 linguas="${linguas} ${lingua}"
179 scarabeus 1.19 sed -e "/add_subdirectory([[:space:]]*${lingua}[[:space:]]*)[[:space:]]*$/ s/^#DONOTCOMPILE //" \
180     -e "/ADD_SUBDIRECTORY([[:space:]]*${lingua}[[:space:]]*)[[:space:]]*$/ s/^#DONOTCOMPILE //" \
181     -i CMakeLists.txt || die "Sed to uncomment linguas_${lingua} failed."
182     fi
183     if [[ -e "${lingua}.po.old" ]]; then
184 wired 1.22 linguas="${linguas} ${lingua}"
185 scarabeus 1.19 mv "${lingua}.po.old" "${lingua}.po"
186     fi
187 jmbsvicetto 1.8 fi
188 zlin 1.5 done
189 wired 1.22 [[ -n "${linguas}" ]] && einfo "Enabling languages: ${linguas}"
190    
191     popd > /dev/null
192     }
193    
194     # @FUNCTION: enable_selected_doc_linguas
195     # @DESCRIPTION:
196     # Enable only selected linguas enabled doc folders.
197     enable_selected_doc_linguas() {
198     debug-print-function ${FUNCNAME} "$@"
199    
200     # if there is no linguas defined we enable everything
201     if ! $(env | grep -q "^LINGUAS="); then
202     return 0
203     fi
204    
205     # @ECLASS-VARIABLE: KDE_DOC_DIRS
206     # @DESCRIPTION:
207     # Variable specifying whitespace separated patterns for documentation locations.
208     # Default is "doc/%lingua"
209     KDE_DOC_DIRS=${KDE_DOC_DIRS:='doc/%lingua'}
210     local linguas
211     for pattern in ${KDE_DOC_DIRS}; do
212    
213     local handbookdir=`dirname ${pattern}`
214     local translationdir=`basename ${pattern}`
215     # Do filename pattern supplied, treat as directory
216     [[ "${handbookdir}" = '.' ]] && handbookdir=${translationdir} && translationdir=
217     [[ -d "${handbookdir}" ]] || die 'wrong doc dir specified'
218    
219     if ! use handbook; then
220     # Disable whole directory
221     sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${handbookdir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \
222     -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${handbookdir}[[:space:]]*)/s/^/#DONOTCOMPILE /" \
223     -i CMakeLists.txt || die 'failed to comment out all handbooks'
224     else
225     # Disable subdirectories recursively
226     comment_all_add_subdirectory "${handbookdir}"
227     # Add requested translations
228     local lingua
229     for lingua in en ${KDE_LINGUAS}; do
230     if [[ ${lingua} = 'en' ]] || use linguas_${lingua}; then
231     if [[ -d "${handbookdir}/${translationdir//%lingua/${lingua}}" ]]; then
232     sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${translationdir//%lingua/${lingua}}/s/^#DONOTCOMPILE //" \
233     -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${translationdir//%lingua/${lingua}}/s/^#DONOTCOMPILE //" \
234     -i "${handbookdir}"/CMakeLists.txt && ! has ${lingua} ${linguas} && linguas="${linguas} ${lingua}"
235     fi
236     fi
237     done
238     fi
239    
240     done
241     [[ -n "${linguas}" ]] && einfo "Enabling handbook translations:${linguas}"
242 zlin 1.5 }
243    
244 scarabeus 1.10 # @FUNCTION: get_build_type
245 ingmar 1.1 # @DESCRIPTION:
246 scarabeus 1.10 # Determine whether we are using live ebuild or tbzs.
247     get_build_type() {
248 scarabeus 1.18 if [[ ${SLOT} = live || ${PV} = *9999* ]]; then
249 scarabeus 1.10 BUILD_TYPE="live"
250     else
251     BUILD_TYPE="release"
252     fi
253     export BUILD_TYPE
254     }
255 ingmar 1.1
256 scarabeus 1.11 # @FUNCTION: migrate_store_dir
257     # @DESCRIPTION:
258 scarabeus 1.15 # Universal store dir migration
259     # * performs split of kdebase to kdebase-apps when needed
260     # * moves playground/extragear kde4-base-style to toplevel dir
261 scarabeus 1.11 migrate_store_dir() {
262 scarabeus 1.15 local cleandir="${ESVN_STORE_DIR}/KDE"
263 scarabeus 1.11 if [[ -d "${cleandir}" ]]; then
264     ewarn "'${cleandir}' has been found. Moving contents to new location."
265     addwrite "${ESVN_STORE_DIR}"
266     # Split kdebase
267     local module
268     if pushd "${cleandir}"/kdebase/kdebase > /dev/null; then
269     for module in `find . -maxdepth 1 -type d -name [a-z0-9]\*`; do
270     module="${module#./}"
271     mkdir -p "${ESVN_STORE_DIR}/kdebase-${module}" && mv -f "${module}" "${ESVN_STORE_DIR}/kdebase-${module}" || \
272     die "Failed to move to '${ESVN_STORE_DIR}/kdebase-${module}'."
273     done
274     popd > /dev/null
275     rm -fr "${cleandir}/kdebase" || \
276     die "Failed to remove ${cleandir}/kdebase. You need to remove it manually."
277     fi
278     # Move the rest
279     local pkg
280     for pkg in "${cleandir}"/*; do
281 scarabeus 1.15 mv -f "${pkg}" "${ESVN_STORE_DIR}"/ || eerror "Failed to move '${pkg}'"
282 scarabeus 1.11 done
283     rmdir "${cleandir}" || die "Could not move obsolete KDE store dir. Please move '${cleandir}' contents to appropriate location (possibly ${ESVN_STORE_DIR}) and manually remove '${cleandir}' in order to continue."
284     fi
285 scarabeus 1.15
286     if ! hasq kde4-meta ${INHERITED}; then
287     case ${KMNAME} in
288     extragear*|playground*)
289     local svnlocalpath="${ESVN_STORE_DIR}"/"${KMNAME}"/"${PN}"
290     if [[ -d "${svnlocalpath}" ]]; then
291     local destdir="${ESVN_STORE_DIR}"/"${ESVN_PROJECT}"/"`basename "${ESVN_REPO_URI}"`"
292     ewarn "'${svnlocalpath}' has been found."
293     ewarn "Moving contents to new location: ${destdir}"
294     addwrite "${ESVN_STORE_DIR}"
295     mkdir -p "${ESVN_STORE_DIR}"/"${ESVN_PROJECT}" && mv -f "${svnlocalpath}" "${destdir}" \
296     || die "Failed to move to '${svnlocalpath}'"
297     # Try cleaning empty directories
298     rmdir "`dirname "${svnlocalpath}"`" 2> /dev/null
299     fi
300     ;;
301     esac
302     fi
303 scarabeus 1.11 }
304    
305 scarabeus 1.10 # Functions handling KMLOADLIBS and KMSAVELIBS
306 ingmar 1.1
307 scarabeus 1.10 # @FUNCTION: save_library_dependencies
308     # @DESCRIPTION:
309     # Add exporting CMake dependencies for current package
310     save_library_dependencies() {
311     local depsfile="${T}/${PN}:${SLOT}"
312    
313 scarabeus 1.15 ebegin "Saving library dependencies in ${depsfile##*/}"
314 scarabeus 1.10 echo "EXPORT_LIBRARY_DEPENDENCIES(\"${depsfile}\")" >> "${S}/CMakeLists.txt" || \
315     die "Failed to save the library dependencies."
316     eend $?
317 ingmar 1.1 }
318    
319 scarabeus 1.10 # @FUNCTION: install_library_dependencies
320 ingmar 1.1 # @DESCRIPTION:
321 scarabeus 1.10 # Install generated CMake library dependencies to /var/lib/kde
322     install_library_dependencies() {
323 scarabeus 1.15 local depsfile="${T}/${PN}:${SLOT}"
324    
325     ebegin "Installing library dependencies as ${depsfile##*/}"
326 abcd 1.28 insinto /var/lib/kde
327 scarabeus 1.10 doins "${depsfile}" || die "Failed to install library dependencies."
328     eend $?
329     }
330 ingmar 1.1
331 scarabeus 1.10 # @FUNCTION: load_library_dependencies
332     # @DESCRIPTION:
333     # Inject specified library dependencies in current package
334     load_library_dependencies() {
335     local pn i depsfile
336 scarabeus 1.15 ebegin "Injecting library dependencies from '${KMLOADLIBS}'"
337 scarabeus 1.10
338     i=0
339     for pn in ${KMLOADLIBS} ; do
340     ((i++))
341 abcd 1.28 depsfile="${EPREFIX}/var/lib/kde/${pn}:${SLOT}"
342 scarabeus 1.10 [[ -r "${depsfile}" ]] || die "Depsfile '${depsfile}' not accessible. You probably need to reinstall ${pn}."
343     sed -i -e "${i}iINCLUDE(\"${depsfile}\")" "${S}/CMakeLists.txt" || \
344     die "Failed to include library dependencies for ${pn}"
345     done
346     eend $?
347 ingmar 1.1 }
348 scarabeus 1.23
349     # @FUNCTION: block_other_slots
350     # @DESCRIPTION:
351     # Create blocks for the current package in other slots when
352     # installed with USE=-kdeprefix
353     block_other_slots() {
354     debug-print-function ${FUNCNAME} "$@"
355    
356 alexxy 1.25 _do_blocker ${PN} 0:${SLOT}
357 scarabeus 1.23 }
358    
359     # @FUNCTION: add_blocker
360     # @DESCRIPTION:
361     # Create correct RDEPEND value for blocking correct package.
362 alexxy 1.25 # Useful for file-collision blocks.
363     # Parameters are package and version(s) to block.
364     # add_blocker kdelibs 4.2.4
365     # If no version is specified, then all versions will be blocked
366     # If any arguments (from 2 on) contain a ":", then different versions
367     # are blocked in different slots. (Unlisted slots get the version without
368     # a ":", if none, then all versions are blocked). The parameter is then of
369     # the form VERSION:SLOT. Any VERSION of 0 means that no blocker will be
370     # added for that slot (or, if no slot, then for any unlisted slot).
371     # A parameter of the form :SLOT means to block all versions from that slot.
372     # If VERSION begins with "<", then "!<foo" will be used instead of "!<=foo".
373     # As a special case, if a parameter with slot "3.5" is passed, then that slot
374     # may also be blocked.
375     #
376     # Versions that match "4.x.50" are equivalent to all slots up to (and including)
377     # "4.x", but nothing following slot "4.x"
378     #
379     # As an example, if SLOT=live, then
380     # add_blocker kdelibs 0 :4.3 '<4.3.96:4.4' 9999:live
381     # will add the following to RDEPEND:
382     # !kdeprefix? ( !kde-base/kdelibs:4.3[-kdeprefix] )
383     # !kdeprefix? ( !<kde-base/kdelibs-4.3.96:4.4[-kdeprefix] )
384 scarabeus 1.27 # !<=kde-base/kdelibs-9999:live
385 scarabeus 1.23 add_blocker() {
386     debug-print-function ${FUNCNAME} "$@"
387    
388 alexxy 1.25 RDEPEND+=" $(_do_blocker "$@")"
389     }
390    
391     # _greater_max_in_slot ver slot
392     # slot must be 4.x or live
393     # returns true if ver is >= the maximum possibile version in slot
394     _greater_max_in_slot() {
395     local ver=$1
396     local slot=$2
397     # If slot is live, then return false
398     # (nothing is greater than the maximum live version)
399     [[ $slot == live ]] && return 1
400     # Otherwise, for slot X.Y, test against X.Y.50
401     local test=${slot}.50
402     version_compare $1 ${test}
403     # 1 = '<', 2 = '=', 3 = '>'
404 scarabeus 1.27 (( $? != 1 ))
405 alexxy 1.25 }
406    
407     # _less_min_in_slot ver slot
408     # slot must be 4.x or live
409     # returns true if ver is <= the minimum possibile version in slot
410     _less_min_in_slot() {
411     local ver=$1
412     local slot=$2
413     # If slot == live, then test with "9999_pre", so that 9999 tests false
414     local test=9999_pre
415     # If slot == X.Y, then test with X.(Y-1).50
416 scarabeus 1.27 [[ $slot != live ]] && test=${slot%.*}.$((${slot#*.} - 1)).50
417 alexxy 1.25 version_compare $1 ${test}
418     # 1 = '<', 2 = '=', 3 = '>'
419 scarabeus 1.27 (( $? != 3 ))
420 alexxy 1.25 }
421    
422     # Internal function used for add_blocker and block_other_slots
423     # This takes the same parameters as add_blocker, but echos to
424     # stdout instead of updating a variable.
425     _do_blocker() {
426     debug-print-function ${FUNCNAME} "$@"
427    
428     [[ -z ${1} ]] && die "Missing parameter"
429     local pkg=kde-base/$1
430     shift
431     local param slot def="unset" var atom
432     # The following variables will hold parameters that contain ":"
433     # - block_3_5
434     # - block_4_1
435     # - block_4_2
436     # - block_4_3
437     # - block_4_4
438     # - block_live
439     for slot in 3.5 ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
440     local block_${slot//./_}="unset"
441     done
442    
443     # This construct goes through each parameter passed, and sets
444     # either def or block_* to the version passed
445     for param; do
446     # If the parameter does not have a ":" in it...
447     if [[ ${param/:} == ${param} ]]; then
448     def=${param}
449     else # the parameter *does* have a ":" in it
450 scarabeus 1.26 # so everything after the : is the slot...
451 alexxy 1.25 slot=${param#*:}
452     # ...and everything before the : is the version
453     local block_${slot//./_}=${param%:*}
454     fi
455     done
456    
457 scarabeus 1.23 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
458 alexxy 1.25 # ${var} contains the name of the variable we care about for this slot
459     # ${!var} is it's value
460     var=block_${slot//./_}
461     # if we didn't pass *:${slot}, then use the unsloted value
462     [[ ${!var} == "unset" ]] && var=def
463    
464 scarabeus 1.26 # If no version was passed, or the version is greater than the maximum
465     # possible version in this slot, block all versions in this slot
466     if [[ ${!var} == "unset" ]] || [[ -z ${!var} ]] || _greater_max_in_slot ${!var#<} ${slot}; then
467 alexxy 1.25 atom=${pkg}
468     # If the version is "0" or less than the minimum possible version in
469     # this slot, do nothing
470     elif [[ ${!var} == "0" ]] || _less_min_in_slot ${!var#<} ${slot}; then
471     continue
472     # If the version passed begins with a "<", then use "<" instead of "<="
473     elif [[ ${!var:0:1} == "<" ]]; then
474     # this also removes the first character of the version, which is a "<"
475     atom="<${pkg}-${!var:1}"
476     else
477     atom="<=${pkg}-${!var}"
478     fi
479 scarabeus 1.27 # we always block our own slot, ignoring kdeprefix
480 alexxy 1.25 if [[ ${SLOT} == ${slot} ]]; then
481 scarabeus 1.27 echo " !${atom}:${slot}"
482     else
483     # we only block other slots on -kdeprefix
484     echo " !kdeprefix? ( !${atom}:${slot}[-kdeprefix] )"
485 alexxy 1.25 fi
486 scarabeus 1.23 done
487 alexxy 1.25
488     # This is a special case block for :3.5; it does not use the
489     # default version passed, and no blocker is output *unless* a version
490     # is passed, or ":3.5" is passed to explicitly request a block on all
491     # 3.5 versions.
492     if [[ ${block_3_5} != "unset" && ${block_3_5} != "0" ]]; then
493     if [[ -z ${block_3_5} ]]; then
494     atom=${pkg}
495     elif [[ ${block_3_5:0:1} == "<" ]]; then
496     atom="<${pkg}-${block_3_5:1}"
497     else
498     atom="<=${pkg}-${block_3_5}"
499     fi
500     echo " !${atom}:3.5"
501     fi
502     }
503    
504     # @FUNCTION: add_kdebase_dep
505     # @DESCRIPTION:
506     # Create proper dependency for kde-base/ dependencies,
507     # adding SLOT when needed (and *only* when needed).
508     # This takes 1 or 2 arguments. The first being the package
509     # name, the optional second, is additional USE flags to append.
510     # The output of this should be added directly to DEPEND/RDEPEND, and
511     # may be wrapped in a USE conditional (but not an || conditional
512 scarabeus 1.26 # without an extra set of parentheses).
513 alexxy 1.25 add_kdebase_dep() {
514     debug-print-function ${FUNCNAME} "$@"
515    
516     [[ -z ${1} ]] && die "Missing parameter"
517    
518     local use=${2:+,${2}}
519    
520 reavertm 1.30 echo " !kdeprefix? ( >=kde-base/${1}-${PV}[aqua=,-kdeprefix${use}] )"
521     echo " kdeprefix? ( >=kde-base/${1}-${PV}:${SLOT}[aqua=,kdeprefix${use}] )"
522 scarabeus 1.23 }

  ViewVC Help
Powered by ViewVC 1.1.20